Option Explicit On
Option Strict Off

Imports System.Runtime.InteropServices

'---------------------------------
' AWG-10K2 API library definitions
'---------------------------------

Module AWG10K2

    '
    ' Return code
    '
    Public Const AWG10K2_OK As Integer = 0
    Public Const AWG10K2_INVALID_ID As Integer = 1
    Public Const AWG10K2_DEVICE_NOT_FOUND As Integer = 2
    Public Const AWG10K2_DEVICE_NOT_OPENED As Integer = 3
    Public Const AWG10K2_INVALID_PARAMETER As Integer = 4
    Public Const AWG10K2_MEMORY_ERROR As Integer = 5
    Public Const AWG10K2_COMMUNICATION_ERROR As Integer = 6
    Public Const AWG10K2_EXECUTION_ERROR As Integer = 7
    Public Const AWG10K2_OTHER_ERROR As Integer = 8

    '
	' Control Mode
    '
	Public Const AWG10K2_CONTROL_MODE_REMOTE As Byte = 0	' [g(PC)
	Public Const AWG10K2_CONTROL_MODE_TRIGGER As Byte = 1	' OgK[
	
    '
	' Output Mode
    '
	Public Const AWG10K2_OUTPUT_MODE_CONTINUE As Byte = 0	' A
	Public Const AWG10K2_OUTPUT_MODE_REPEAT As Byte = 1		' JԂ
	
    '
	' Trigger Type
    '
	Public Const AWG10K2_TRIGGER_TYPE_RISING As Byte = 0	' GbW
	Public Const AWG10K2_TRIGGER_TYPE_FALLING As Byte = 1	' GbW
	
    '
	' Status
    '
    Public Const AWG10K2_STATUS_NO_DATA As Byte = 0   ' g`o͒~(g`f[^ݒ)
    Public Const AWG10K2_STATUS_READY As Byte = 1     ' g`o͒~(g`f[^ݒ)
    Public Const AWG10K2_STATUS_RUNNING As Byte = 2   ' g`o͒

    '
    ' Functions definitions
    '
    Public Declare Function AWG10K2_GetNumberOfDevices Lib "AWG10K2.dll" (ByRef Number As Integer) As Integer
    Public Declare Function AWG10K2_GetSerialNumber Lib "AWG10K2.dll" (ByVal Index As Integer, ByRef SerialNumber As Integer) As Integer
    Public Declare Function AWG10K2_Open Lib "AWG10K2.dll" (ByRef ID As Byte) As Integer
    Public Declare Function AWG10K2_OpenBySerialNumber Lib "AWG10K2.dll" (ByVal SerialNumber As Integer, ByRef ID As Byte) As Integer
    Public Declare Function AWG10K2_Close Lib "AWG10K2.dll" (ByVal ID As Byte) As Integer

    Public Declare Ansi Function AWG10K2_SetFile Lib "AWG10K2.dll" (ByVal ID As Byte, ByVal FilePath As String) As Integer
    Public Declare Function AWG10K2_SetParametersAndWaveData Lib "AWG10K2.dll" (ByVal ID As Byte, ByVal ControlMode As Byte, ByVal OutputMode As Byte, ByVal RepeatCount As Integer, ByVal TriggerType As Byte, ByVal SamplingRate As Integer, ByVal SamplingCount As Integer, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal WaveData As Object) As Integer
    Public Declare Function AWG10K2_Start Lib "AWG10K2.dll" (ByVal ID As Byte) As Integer
    Public Declare Function AWG10K2_Stop Lib "AWG10K2.dll" (ByVal ID As Byte) As Integer
    Public Declare Function AWG10K2_GetStatus Lib "AWG10K2.dll" (ByVal ID As Byte, ByRef Status As Byte) As Integer
    Public Declare Function AWG10K2_OutputPort Lib "AWG10K2.dll" (ByVal ID As Byte, ByVal Port As Byte) As Integer
    Public Declare Function AWG10K2_InputPort Lib "AWG10K2.dll" (ByVal ID As Byte, ByRef Port As Byte) As Integer

End Module
